//
//  UHRLoadProgramTests.m
//  TestBenchTests
//
//  Created by Elisa Silva on 15/10/21.
//
//  Copyright 2021 Elisa Silva
//  
//  Permission is hereby granted, free of charge, to any person obtaining a 
//  copy of this software and associated documentation files (the "Software"), 
//  to deal in the Software without restriction, including without limitation 
//  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//  and/or sell copies of the Software, and to permit persons to whom the Software 
//  is furnished to do so, subject to the following conditions:
//  
//  The above copyright notice and this permission notice shall be included in 
//  all copies or substantial portions of the Software.
//  
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
//  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
//  WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
//  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#import <XCTest/XCTest.h>
#import <OCMock/OCMock.h>

#import "UHRLoadProgram.h"


@interface UHRLoadProgramTests : XCTestCase

@end

@implementation UHRLoadProgramTests

- (void)testLoadSAMPLEProgram {
    NSData *data = [UHRLoadProgram dataForProgramNamed:@"SAMPLE.bin"];
    XCTAssert(data.length == 4);
    XCTAssert(((char *)data.bytes)[0] == 0x37);
    XCTAssert(((char *)data.bytes)[1] == 0x0);
    XCTAssert(((char *)data.bytes)[2] == 0x0);
    XCTAssert(((char *)data.bytes)[3] == 0x0);
}

- (void)testLoadInvalidProgram {
    NSData *data = [UHRLoadProgram dataForProgramNamed:@"thisProgramDoesNotExists"];
    XCTAssert(data == nil);
}

@end
