//
//  UHRModuleInterface.h
//  Peeler
//
//  Created by Elisa Silva on 07/10/21.
//
//  Copyright 2021 Elisa Silva
//  
//  Permission is hereby granted, free of charge, to any person obtaining a 
//  copy of this software and associated documentation files (the "Software"), 
//  to deal in the Software without restriction, including without limitation 
//  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
//  and/or sell copies of the Software, and to permit persons to whom the Software 
//  is furnished to do so, subject to the following conditions:
//  
//  The above copyright notice and this permission notice shall be included in 
//  all copies or substantial portions of the Software.
//  
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
//  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
//  WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
//  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#import <Foundation/Foundation.h>

#import "UHRPeelerTypes.h"

@protocol UHRModuleInterface <NSObject>

/// @brief: Change the value of a signal
- (void)pokeSignal:(UHREnum)signal withValue:(UHRWord)value;

/// @brief: Return the value of a signal
- (UHRWord)peekSignal:(UHREnum)signal;

/// @brief: Evaluate the simulation of the model at a given time
- (void)evaluateStateAtTime:(UHRTimeUnit)time;

/// @brief: Get the signal of for the clock wire
- (UHREnum)clockSignal;

/// @brief: Get the name of the signals
- (NSDictionary *)signalNames;

@end
